# Utiliser une image Docker Node.js spécifique pour exécuter les étapes de la pipeline
image: node:16

# Étapes de la pipeline
stages:
  - install
  - lint
  - test
  - build

# Variables globales
variables:
  # Dossier où les artefacts seront stockés
  BUILD_DIR: dist

# Étape d'installation des dépendances
install:
  stage: install
  script:
    - cd myapp && npm i
  cache:
    key: ${CI_COMMIT_REF_SLUG}
    paths:
      - node_modules/

# Étape de linting pour vérifier le code
lint:
  stage: lint
  script:
    - cd myapp && npm run lint

# Étape de tests unitaires
test:
  stage: test
  script:
    - cd myapp && npm run test -- --watch=false --browsers=ChromeHeadless
  artifacts:
    when: always
    reports:
      junit:
        - coverage/junit/test-results.xml
    paths:
      - coverage/

# Étape de build pour construire l'application Angular
build:
  stage: build
  script:
    - cd myapp && npm run build -- --output-path=$BUILD_DIR
  artifacts:
    paths:
      - $BUILD_DIR
  rules:
    - if: '$CI_COMMIT_BRANCH == "main"'
